from ngsolve import *
from netgen.geom2d import CSG2d, Rectangle

geo = CSG2d()

rect = Rectangle( pmin=(0,0), pmax=(1,1), mat="mat1", right="right", left="left", top="top", bottom="bottom")

rect1 = Rectangle( pmin=(0,0.45), pmax=(1,0.55), mat="mat2",bc="interface", right="right", left="left")
rect2 = Rectangle( pmin=(0.45,0), pmax=(0.55,1), mat="mat2",bc="interface", top="top", bottom="bottom")
cross1 = rect1+rect2

rect3 = Rectangle( pmin=(-1,0.45), pmax=(2,0.55), mat="mat2",bc="interface")
rect4 = Rectangle( pmin=(0.45,-1), pmax=(0.55,2), mat="mat2",bc="interface")
cross2 = rect3+rect4
cross2.Rotate(45, center=(0.5,0.5))

cross = cross1+cross2

geo.Add(rect-cross)
geo.Add(cross*rect)

mesh = Mesh(geo.GenerateMesh(maxh=0.3))
Draw(mesh)

Draw(CF( [1,2] ), mesh, "materials")
